/* Jacobians 6 */
#include "WaterTank_TestSingleWaterTank_model.h"
#include "WaterTank_TestSingleWaterTank_12jac.h"
#include "simulation/jacobian_util.h"
#include "util/omc_file.h"
int WaterTank_TestSingleWaterTank_functionJacH_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int WaterTank_TestSingleWaterTank_functionJacF_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int WaterTank_TestSingleWaterTank_functionJacD_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int WaterTank_TestSingleWaterTank_functionJacC_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
int WaterTank_TestSingleWaterTank_functionJacB_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  TRACE_POP
  return 0;
}
/* constant equations */
/* dynamic equations */

/*
equation index: 37
type: SIMPLE_ASSIGN
tank.valve_powerIn_p.$pDERA.dummyVarA = tank.gravity * tank.volume.SeedA * tank.liquid_density
*/
void WaterTank_TestSingleWaterTank_eqFunction_37(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 0;
  const int equationIndexes[2] = {1,37};
  jacobian->tmpVars[4] /* tank.valve_powerIn_p.$pDERA.dummyVarA JACOBIAN_TMP_VAR */ = ((data->simulationInfo->realParameter[6] /* tank.gravity PARAM */)) * ((jacobian->seedVars[1] /* tank.volume.SeedA SEED_VAR */) * ((data->simulationInfo->realParameter[8] /* tank.liquid_density PARAM */)));
  TRACE_POP
}

/*
equation index: 38
type: SIMPLE_ASSIGN
tank.level.$pDERA.dummyVarA = tank.volume.SeedA / tank.area
*/
void WaterTank_TestSingleWaterTank_eqFunction_38(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 1;
  const int equationIndexes[2] = {1,38};
  jacobian->tmpVars[1] /* tank.level.$pDERA.dummyVarA JACOBIAN_TMP_VAR */ = DIVISION(jacobian->seedVars[1] /* tank.volume.SeedA SEED_VAR */,(data->simulationInfo->realParameter[2] /* tank.area PARAM */),"tank.area");
  TRACE_POP
}

/*
equation index: 39
type: SIMPLE_ASSIGN
tank.drain_p_e.$pDERA.dummyVarA = if control1.valve <> 0.0 then tank.valve_powerIn_p.$pDERA.dummyVarA else 0.0
*/
void WaterTank_TestSingleWaterTank_eqFunction_39(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 2;
  const int equationIndexes[2] = {1,39};
  jacobian->tmpVars[0] /* tank.drain_p_e.$pDERA.dummyVarA JACOBIAN_TMP_VAR */ = (((data->localData[0]->realVars[13] /* control1.valve DISCRETE */) != 0.0)?jacobian->tmpVars[4] /* tank.valve_powerIn_p.$pDERA.dummyVarA JACOBIAN_TMP_VAR */:0.0);
  TRACE_POP
}

/*
equation index: 40
type: SIMPLE_ASSIGN
tank.valve_powerOut_f.$pDERA.dummyVarA = tank.drain_p_e.$pDERA.dummyVarA / tank.drain_r
*/
void WaterTank_TestSingleWaterTank_eqFunction_40(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 3;
  const int equationIndexes[2] = {1,40};
  jacobian->tmpVars[6] /* tank.valve_powerOut_f.$pDERA.dummyVarA JACOBIAN_TMP_VAR */ = DIVISION(jacobian->tmpVars[0] /* tank.drain_p_e.$pDERA.dummyVarA JACOBIAN_TMP_VAR */,(data->simulationInfo->realParameter[3] /* tank.drain_r PARAM */),"tank.drain_r");
  TRACE_POP
}

/*
equation index: 41
type: SIMPLE_ASSIGN
$DER.tank.volume.$pDERA.dummyVarA = -(if control1.valve <> 0.0 then tank.valve_powerOut_f.$pDERA.dummyVarA else 0.0)
*/
void WaterTank_TestSingleWaterTank_eqFunction_41(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 4;
  const int equationIndexes[2] = {1,41};
  jacobian->resultVars[1] /* der(tank.volume.$pDERA.dummyVarA) JACOBIAN_VAR */ = (-((((data->localData[0]->realVars[13] /* control1.valve DISCRETE */) != 0.0)?jacobian->tmpVars[6] /* tank.valve_powerOut_f.$pDERA.dummyVarA JACOBIAN_TMP_VAR */:0.0)));
  TRACE_POP
}

/*
equation index: 42
type: SIMPLE_ASSIGN
$DER.tank.valve_outflow_int.$pDERA.dummyVarA = if tank.valve_powerOut_f < 0.0 then 0.0 else 0.1 * sign(tank.valve_powerOut_f) * tank.valve_powerOut_f.$pDERA.dummyVarA
*/
void WaterTank_TestSingleWaterTank_eqFunction_42(DATA *data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH
  const int baseClockIndex = 0;
  const int subClockIndex = 5;
  const int equationIndexes[2] = {1,42};
  modelica_boolean tmp0;
  tmp0 = Less((data->localData[0]->realVars[11] /* tank.valve_powerOut_f variable */),0.0);
  jacobian->resultVars[0] /* der(tank.valve_outflow_int.$pDERA.dummyVarA) JACOBIAN_VAR */ = (tmp0?0.0:(0.1) * ((sign((data->localData[0]->realVars[11] /* tank.valve_powerOut_f variable */))) * (jacobian->tmpVars[6] /* tank.valve_powerOut_f.$pDERA.dummyVarA JACOBIAN_TMP_VAR */)));
  TRACE_POP
}

OMC_DISABLE_OPT
int WaterTank_TestSingleWaterTank_functionJacA_constantEqns(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH

  int index = WaterTank_TestSingleWaterTank_INDEX_JAC_A;
  
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_functionJacA_column(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian, ANALYTIC_JACOBIAN *parentJacobian)
{
  TRACE_PUSH

  int index = WaterTank_TestSingleWaterTank_INDEX_JAC_A;
  WaterTank_TestSingleWaterTank_eqFunction_37(data, threadData, jacobian, parentJacobian);
  WaterTank_TestSingleWaterTank_eqFunction_38(data, threadData, jacobian, parentJacobian);
  WaterTank_TestSingleWaterTank_eqFunction_39(data, threadData, jacobian, parentJacobian);
  WaterTank_TestSingleWaterTank_eqFunction_40(data, threadData, jacobian, parentJacobian);
  WaterTank_TestSingleWaterTank_eqFunction_41(data, threadData, jacobian, parentJacobian);
  WaterTank_TestSingleWaterTank_eqFunction_42(data, threadData, jacobian, parentJacobian);
  TRACE_POP
  return 0;
}

int WaterTank_TestSingleWaterTank_initialAnalyticJacobianH(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int WaterTank_TestSingleWaterTank_initialAnalyticJacobianF(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int WaterTank_TestSingleWaterTank_initialAnalyticJacobianD(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int WaterTank_TestSingleWaterTank_initialAnalyticJacobianC(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
int WaterTank_TestSingleWaterTank_initialAnalyticJacobianB(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  TRACE_POP
  jacobian->availability = JACOBIAN_NOT_AVAILABLE;
  return 1;
}
OMC_DISABLE_OPT
int WaterTank_TestSingleWaterTank_initialAnalyticJacobianA(DATA* data, threadData_t *threadData, ANALYTIC_JACOBIAN *jacobian)
{
  TRACE_PUSH
  size_t count;

  FILE* pFile = openSparsePatternFile(data, threadData, "WaterTank_TestSingleWaterTank_JacA.bin");
  
  initAnalyticJacobian(jacobian, 2, 2, 13, NULL, jacobian->sparsePattern);
  jacobian->sparsePattern = allocSparsePattern(2, 2, 1);
  jacobian->availability = JACOBIAN_AVAILABLE;
  
  /* read lead index of compressed sparse column */
  count = omc_fread(jacobian->sparsePattern->leadindex, sizeof(unsigned int), 2+1, pFile, FALSE);
  if (count != 2+1) {
    throwStreamPrint(threadData, "Error while reading lead index list of sparsity pattern. Expected %d, got %zu", 2+1, count);
  }
  
  /* read sparse index */
  count = omc_fread(jacobian->sparsePattern->index, sizeof(unsigned int), 2, pFile, FALSE);
  if (count != 2) {
    throwStreamPrint(threadData, "Error while reading row index list of sparsity pattern. Expected %d, got %zu", 2+1, count);
  }
  
  /* write color array */
  /* color 1 with 2 columns */
  readSparsePatternColor(threadData, pFile, jacobian->sparsePattern->colorCols, 1, 2);
  
  omc_fclose(pFile);
  
  TRACE_POP
  return 0;
}



